(define (split from to par)
  (+ from (* (- to from) par)))

(define (sierpinski h1 h2 h3 iter par)
  (let rec ((s1 (make-segment h1 h2)) (s1f 0) (s1t 1)
            (s2 (make-segment h2 h3)) (s2f 0) (s2t 1)
	    (s3 (make-segment h3 h1)) (s3f 0) (s3t 1)
	    (i iter))
	(if (> i 1)
	  (let ((p1 (split s1f s1t par))
	        (p2 (split s2f s2t par))
	        (p3 (split s3f s3t par))
	        (i2 (- i 1)))
	    (let ((ph1 (hget-center (make-parametric-point s1 p1)))
	          (ph2 (hget-center (make-parametric-point s2 p2)))
	          (ph3 (hget-center (make-parametric-point s3 p3))))
  	      (rec s1 s1f p1
  	           (make-segment ph1 ph3) 0 1
	  	   s3 p3 s3t i2)
	      (rec s1 p1 s1t
		   s2 s2f p2
	           (make-segment ph2 ph1) 0 1 i2)
	      (rec (make-segment ph3 ph2) 0 1
	           s2 p2 s2t
		   s3 s3f p3 i2))))))

(define (sierp tlo iter)
(trans-main tlo
	    (lambda ()
	      (sierpinski (coords -60 -60) (coords 60 -60) (coords 0 60) iter 0.5)
	    ) (lambda x x) "Sierpinski Triangle"))
