
#ifndef _FONT_INTERNAL_H_
#define _FONT_INTERNAL_H_

#include "font/font.h"

#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_CACHE_H
#include FT_CACHE_IMAGE_H
#include FT_CACHE_CHARMAP_H
#include FT_SIZES_H
#include FT_TYPE1_TABLES_H
#include FT_TRUETYPE_IDS_H
#include FT_TRUETYPE_TABLES_H
#include FT_TRUETYPE_TAGS_H
#include FT_SFNT_NAMES_H
#include FT_OUTLINE_H

#ifdef __GNUC__

extern typeof(FT_Activate_Size) *font_Activate_Size;
extern typeof(FTC_CMapCache_Lookup) *font_CMapCache_Lookup;
extern typeof(FTC_CMapCache_New) *font_CMapCache_New;
extern typeof(FTC_ImageCache_Lookup) *font_ImageCache_Lookup;
extern typeof(FTC_ImageCache_New) *font_ImageCache_New;
extern typeof(FTC_Manager_Done) *font_Manager_Done;
extern typeof(FTC_Manager_LookupFace) *font_Manager_LookupFace;
extern typeof(FTC_Manager_LookupSize) *font_Manager_LookupSize;
extern typeof(FTC_Manager_New) *font_Manager_New;
extern typeof(FT_Done_Face) *font_Done_Face;
extern typeof(FT_Done_FreeType) *font_Done_FreeType;
extern typeof(FT_Done_Glyph) *font_Done_Glyph;
extern typeof(FT_Get_Glyph) *font_Get_Glyph;
extern typeof(FT_Get_Glyph_Name) *font_Get_Glyph_Name;
extern typeof(FT_Get_Char_Index) *font_Get_Char_Index;
extern typeof(FT_Get_Name_Index) *font_Get_Name_Index;
extern typeof(FT_Get_Postscript_Name) *font_Get_Postscript_Name;
extern typeof(FT_Get_PS_Font_Info) *font_Get_PS_Font_Info;
extern typeof(FT_Get_Sfnt_Name_Count) *font_Get_Sfnt_Name_Count;
extern typeof(FT_Get_Sfnt_Name) *font_Get_Sfnt_Name;
extern typeof(FT_Get_Sfnt_Table) *font_Get_Sfnt_Table;
extern typeof(FT_Glyph_Get_CBox) *font_Glyph_Get_CBox;
extern typeof(FT_Glyph_To_Bitmap) *font_Glyph_To_Bitmap;
extern typeof(FT_Glyph_Transform) *font_Glyph_Transform;
extern typeof(FT_Init_FreeType) *font_Init_FreeType;
extern typeof(FT_Load_Glyph) *font_Load_Glyph;
extern typeof(FT_Load_Char) *font_Load_Char;
extern typeof(FT_Load_Sfnt_Table) *font_Load_Sfnt_Table;
extern typeof(FT_New_Face) *font_New_Face;
extern typeof(FT_RoundFix) *font_RoundFix;
extern typeof(FT_Select_Charmap) *font_Select_Charmap;
extern typeof(FT_Outline_Decompose) *font_Outline_Decompose;
extern typeof(FT_Glyph_Copy) *font_Glyph_Copy;

#else

extern FT_Error (*font_Activate_Size)(FT_Size size);
extern FT_UInt (*font_CMapCache_Lookup)(FTC_CMapCache, FTC_FaceID, FT_Int, FT_UInt32);
extern FT_Error (*font_CMapCache_New)(FTC_Manager, FTC_CMapCache *);
extern FT_Error (*font_ImageCache_Lookup)(FTC_ImageCache, FTC_ImageType, FT_UInt, FT_Glyph *, FTC_Node *);
extern FT_Error (*font_ImageCache_New)(FTC_Manager, FTC_ImageCache  *);
extern void (*font_Manager_Done)(FTC_Manager);
extern FT_Error (*font_Manager_LookupFace)(FTC_Manager, FTC_FaceID, FT_Face *);
extern FT_Error (*font_Manager_LookupSize)(FTC_Manager, FTC_Scaler, FT_Size *);
extern FT_Error (*font_Manager_New)(FT_Library library, FT_UInt, FT_UInt, FT_ULong, FTC_Face_Requester, FT_Pointer, FTC_Manager *);
extern FT_Error (*font_Done_Face)(FT_Face);
extern FT_Error (*font_Done_FreeType)(FT_Library);
extern void (*font_Done_Glyph)(FT_Glyph);
extern FT_Error (*font_Get_Glyph)(FT_GlyphSlot, FT_Glyph *);
extern FT_Error (*font_Get_Glyph_Name)(FT_Face, FT_UInt, FT_Pointer, FT_UInt);
extern FT_UInt (*font_Get_Char_Index)(FT_Face);
extern FT_UInt (*font_Get_Name_Index)(FT_Face, FT_String *);
extern const char *(*font_Get_Postscript_Name)(FT_Face);
extern FT_Error (*font_Get_PS_Font_Info)(FT_Face, PS_FontInfoRec *);
extern FT_UInt (*font_Get_Sfnt_Name_Count)(FT_Face);
extern FT_Error (*font_Get_Sfnt_Name)(FT_Face, FT_UInt, FT_SfntName *);
extern void *(*font_Get_Sfnt_Table)(FT_Face, FT_Sfnt_Tag);
extern void (*font_Glyph_Get_CBox)(FT_Glyph, FT_UInt, FT_BBox *);
extern FT_Error (*font_Glyph_To_Bitmap)(FT_Glyph *, FT_Render_Mode, FT_Vector *, FT_Bool);
extern FT_Error (*font_Glyph_Transform)(FT_Glyph, FT_Matrix *, FT_Vector *);
extern FT_Error (*font_Init_FreeType)(FT_Library *);
extern FT_Error (*font_Load_Glyph)(FT_Face, FT_UInt, FT_Int32);
extern FT_Error (*font_Load_Char)(FT_Face, FT_ULong, FT_Int32);
extern FT_Error (*font_Load_Sfnt_Table)(FT_Face, FT_ULong, FT_Long, FT_Byte *, FT_ULong *);
extern FT_Error (*font_New_Face)(FT_Library, const char *, FT_Long, FT_Face *);
extern FT_Fixed (*font_RoundFix)(FT_Fixed);
extern FT_Error (*font_Select_Charmap)(FT_Face, FT_Encoding);
extern FT_Error (*font_Outline_Decompose)(FT_Outline *, const FT_Outline_Funcs *, void *);
extern FT_Error (*font_Glyph_Copy)(FT_Glyph, FT_Glyph *);

#endif


extern FT_Library font_lib;
extern FTC_Manager font_mgr;
extern FTC_ImageCache font_img_cache;
extern FTC_CMapCache font_cmap_cache;

#endif
