#include "lib/lib.h"
#include "font/font.h"

int main(int argc, char **argv)
{
	FILE *out;
	int fd;

	font_init(argv[0]);

	if (argc < 3) {
		err("Syntax: pfb2pfa <inputfile> <outputfile>\n");
		return 1;
	}
	fd = font_load_file(argv[1]);
	if (!fd) {
		err("Error loading file '%s'\n", argv[1]);
		return 1;
	}
	out = fopen(argv[2], "w");
	if (!out) {
		err("Error opening file '%s' for writing\n", argv[2]);
		return 1;
	}

	if (font_pfb_to_pfa(fd, out)<0) {
		err("Error occured during conversion\n");
		return 1;
	}
	fclose(out);
	font_finish();
	return 0;
}
