#include "lib/lib.h"
#include "font/font.h"

int main(int argc, char **argv)
{
	FILE *out;
	int fontid;
	char *fontname = "Noname";

	if (argc < 3) {
		err("Syntax: tt2t42 <inputfile> <outputfile> [fontname]\n");
		return 1;
	}

	font_init(argv[0]);

	fontid = font_load_file(argv[1]);
	if (fontid < 0) {
		err("Error loading font '%s'\n", argv[1]);
		return 1;
	}

	out = fopen(argv[2], "w");
	if (!out) {
		err("Error opening file '%s' for writing\n", argv[2]);
		return 1;
	}

	if (argc > 3)
		fontname = argv[3];

	if (font_tt_to_type42(fontid, fontname, out)<0) {
		err("Error occured during conversion\n");
		return 1;
	}

	fclose(out);
	font_finish();
	return 0;
}
