#ifndef _VRR_GEOMLIB_CACHE_H_
#define _VRR_GEOMLIB_CACHE_H_

#include "geomlib/base.h"

/* GEOM_USE_LOCAL_CACHE / GEOM_USE_TINY_CACHE / GEOM_USE_NO_CACHE / global cache */
//#define GEOM_USE_LOCAL_CACHE

/* Cache initialization */
#ifdef GEOM_USE_NO_CACHE
static inline void geom_cache_init(void) {}
static inline void geom_cache_finish(void) {}
#else
void geom_cache_init(void);
void geom_cache_finish(void);
#endif


/* Bezier expansion */
struct geom_expansion {
	struct geom_fpath path;
};

struct geom_expansion *geom_item_expand(void *item);
void geom_expansion_unref(struct geom_expansion *e);
#ifdef GEOM_USE_NO_CACHE
static inline void geom_item_expansion_release(void UNUSED *item) {}
#else
void geom_item_expansion_release(void *item);
#endif


#endif
