#define GEOM_SOURCE
#include "geomlib/base.h"


/* Global varribles. */

uns geom_class_count = 1;
struct geom_class *geom_class_table[GEOM_CLASS_ID_COUNT] = { [1] = (void *)&geom_o_class };
struct geom_o_class geom_o_class = { geom_o_INIT
	.class_id = 1,
	.instance_size = sizeof(struct geom_o),
	.class_name = "o",
};


/* geom_class_assert */

const struct geom_class *geom_class_assert(GEOM_ASSERT_DEF, const struct geom_class *pclass)
{
	if (!PTEST(pclass))
		die(GEOM_ASSERT_FORMAT ": %p is invalid class pointer\n", GEOM_ASSERT_COPY, (void *)pclass);
	return pclass;
}


/* geom_instance_assert */

const void *geom_instance_assert(GEOM_ASSERT_DEF, const void *instance)
{
	if (!PTEST(instance))
		die(GEOM_ASSERT_FORMAT ": instance pointer is NULL\n", GEOM_ASSERT_COPY);
	if (!PTEST(geom_class_table[((struct geom_o *)instance)->class_id]))
		die(GEOM_ASSERT_FORMAT ": instance %p has invalid class id\n", GEOM_ASSERT_COPY, instance);
	return instance;
}


/* geom_instance_is */

int geom_instance_is(const void *instance, const struct geom_class *pclass)
{
	struct geom_class *c;

	GASSERT(instance, instance);
	GASSERT(class, pclass);
	c = geom_class_table[((struct geom_o *)instance)->class_id];
	while (c != pclass) {
		c = c->class_parent;
		if (!c)
			return 0;
	}
	return 1;
}


/* geom_instance_is_assert */

const void *geom_instance_is_assert(GEOM_ASSERT_DEF, const void *instance, const struct geom_class *pclass)
{
	struct geom_class *c;

	geom_instance_assert(GEOM_ASSERT_COPY, instance);
	geom_class_assert(GEOM_ASSERT_COPY, pclass);
	c = geom_class_table[((struct geom_o *)instance)->class_id];
	while (c != pclass) {
		c = c->class_parent;
		if (!c)
			die(GEOM_ASSERT_FORMAT ": instance %p of class %s is not descendant of class %s\n", GEOM_ASSERT_COPY,
				instance, geom_instance_class_name(instance), pclass->class_name);
	}
	return instance;
}


