#ifndef _VRR_GEOMLIB_ERR_H_
#define _VRR_GEOMLIB_ERR_H_

/**
 * @file geomlib/err.h
 *
 * Geomlib - Error handling routines.
 */

#include "geomlib/base.h"


/* Error codes */

#define GEOM_ERR_NUMERIC                          (-10)

#define GEOM_ERR_MATRIX_NO_SOLUTION               (-20)
#define GEOM_ERR_MATRIX_SINGULAR                  (-21)

#define GEOM_ERR_CONIC_TOO_LONG                   (-30)
#define GEOM_ERR_CONIC_DEGENERATED                (-31)
#define GEOM_ERR_CONIC_AMBIGUOUS                  (-32)

#define GEOM_ERR_TRANSFORM_SINGULAR               (-40)
#define GEOM_ERR_TRANSFORM_NOT_SIMILAR            (-41)

#define GEOM_ERR_PATH_EMPTY                       (-50)
#define GEOM_ERR_PATH_CLOSED                      (-51)

#define GEOM_ERR_ITEM_INVALID                     (-60)
#define GEOM_ERR_ITEM_NOT_IMPLEMENTED             (-61)

#define GEOM_ERR_CONVERSION_IMPOSSIBLE            (-70)


extern int geom_errno;
char *geom_err_str(int err);


#endif

