#include "lib/lib.h"
#include "geomlib/geomlib.h"

struct geom_expand
{
	u8 typ, flags, ref_count; //  ... co bude zapotrebi.
	struct geom_rtree_obj rtree; // Do kernelu by se hodilo propojeni expanzi s rtree. Asi se to tim zkomplikuje, ale usetri se starosti v kernelu. Tento node nebude vyuzit pro geom, ktere nejsou v kernelu, ale tech by nemelo byt mnoho. Navic je tu moznost zruseni vsech expanzi pri zavreni vsech view od daneho tlo.
	void *p; // Asi ukazatel na geom.
}

// Klicem asi bude ukazatel na geom_xxx.

#define HASH_NODE struct geom_expand_rtree
#define HASH_PREFIX(x) hash_ ## x
#define HASH_KEY_ATOMIC void *
#define HASH_WANT_CLEANUP
#define HASH_WANT_FIND
#define HASH_WANT_INSERT
#define HASH_WANT_REMOVE
#define HASH_GIVE_ALLOC
static inline void expand_sht_free(struct expand_sht_table *table UNUSED, void *p UNUSED) { }
#define HASH_GIVE_HASHFN
static inline uns expand_sht_hash(struct expand_sht_table *table UNUSED, struct go *go) { return hash_int((intptr_t)go); }
#define HASH_CONSERVE_SPACE
#define HASH_ATOMIC_TYPE struct go*
//#define HASH_TABLE_DYNAMIC Asi staci jedna tabulka.
#include "lib/sht.h"

// Principielne se muze ukladat libovolna expanze, ale hodit se asi bude jen cesta.
struct geom_expand_path
{
	struct hash_bucket bucket; // vygenerovane hash tabulkou
	cnode lru;
	struct geom_path path;
};

// Vrati expanzi daneho geom na cestu z bezierek.
const struct geom_path* geom_expand_path(void *geom);

// Vrati bbox ulozeny v rtree. Geomlib jej nesmi menit sam, protoze stary bbox kernel potrebuje znat pri volani hooku pro vykreslovatko. Pak kernel zavola aktualizaci. Hmm, ponekud neprijemne. Mozna to pujde obejit. Nejdriv se domluvim s Pavlem.
const struct geom_rectangle* geom_expand_bbox(void *geom);

// Vlozi geom do rtree a hash. Pro vlozeni do rtree bude potrebovat bbox, ke kteremu je nekdy zapotrebi expanze, kterou si muze spocitat a ulozit.
void geom_expand_insert(struct geom_rtree *root, void *geom);

// Kernel provedl zmenu ...
void geom_expand_update(struct geom_rtree *root, void *geom);

// Unlink v kernelu -> nutno vyhodit z rtree. Asi je mozne vyhodit i expanzi, tj. vyhodit z hash.
void geom_expand_remove(struct geom_rtree *root, void *geom);

// Nejaky init a destroy, ale to neni momentalne nutne resit.
