/** \file gui/glt_gui.h
  \brief GUILE-link - interface functions for gui data types. */

#ifndef _GUI_GLT_GUI_H_
#define _GUI_GLT_GUI_H_



static inline struct window * vptr (SCM obj) { return ((struct window *) SCM_SMOB_DATA(obj)); }

uns is_window_proxy(SCM proxy);

static uns proxy_is_valid(SCM proxy)
{ return (vptr (proxy) != NULL); }


static uns is_specific_window_proxy(SCM proxy, int type)
{
    return (is_window_proxy (proxy) && proxy_is_valid (proxy) &&
	    ((type < 0) || (vptr (proxy) -> type == (uns) type)));
}

static inline struct window * scm2window (SCM obj)
{ return is_window_proxy (obj) ? vptr (obj) : NULL; }

SCM window2scm(struct window *p);

void window_proxy_clean (struct window *p);

#define ID_window -1
#define ID_view WT_VIEW

static inline void assert_SW(SCM obj, unsigned int pos, const char *subr, int type)
{ SCM_ASSERT (is_specific_window_proxy (obj, type), obj, pos, subr); }

static inline void * in_SW(SCM obj)
{ return scm2window (obj); }

static inline SCM out_SW (void *ptr)
{ return window2scm (ptr); }

void glt_gui_init(void);

#endif
