#undef LOCAL_DEBUG

#include "lib/lib.h"
#include <gtk/gtk.h>
#include "gui/main.h"
#include "gui/cmdmgr.h"

GtkWidget * main_window;
static GtkWidget * main_menu_bar;
static GtkWidget * main_vbox, * menubox, * toolbox;
static GtkWidget * toolbar;

// callbacks
static void main_window_destroy( GtkWidget *widget UNUSED, gpointer data UNUSED)
{
	open_windows_cnt--;
	main_window_open--;
	if(!open_windows_cnt) main_quit();
}

static gboolean delete_event( GtkWidget * widget UNUSED, GdkEvent * event UNUSED, gpointer data UNUSED)
{
	DBG("delete event occurred\n");
	gtk_widget_hide( main_window );
	open_windows_cnt--;
	main_window_open--;
	if(!open_windows_cnt) main_quit ();
	return TRUE;
}

void main_window_show(void){ gtk_widget_show( main_window ); }

void main_window_refresh_menu(void)
{
	if ( !main_menu_bar || !sync_menu( main_menu_bar, VCL_MAIN_MENU ) ){
		struct cmddata cd = { NULL, NULL };
		DBG("Main menu needs rebuilding!\n");
		if ( main_menu_bar )
			gtk_container_remove( GTK_CONTAINER(menubox), main_menu_bar );
		gtk_widget_show( main_menu_bar = create_menu( VCL_MAIN_MENU, cd ) );// create menubar
		gtk_box_pack_start( GTK_BOX( menubox), main_menu_bar, FALSE, FALSE, 0 );
		DBG("Rebuild OK\n");
	}
}
void main_window_refresh_toolbar(void)
{
	if ( !toolbar || !sync_toolbar( toolbar, VCL_MAIN_TBAR ) ){
		struct cmddata cd = { NULL, NULL };
		DBG("Toolbar needs rebuilding!\n");
		if ( toolbar )
			gtk_container_remove( GTK_CONTAINER(toolbox), toolbar );
		gtk_widget_show( toolbar = create_toolbar( VCL_MAIN_TBAR, 0, cd ) );// create toolbar
		gtk_box_pack_start( GTK_BOX( toolbox), toolbar, FALSE, FALSE, 0 );
		DBG("Rebuild OK\n");
	}
}
void main_window_create(void)
{
	open_windows_cnt++;
	main_window_open++;

	// new window
	main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	g_signal_connect (G_OBJECT (main_window), "delete_event", G_CALLBACK (delete_event), NULL);
	g_signal_connect (G_OBJECT (main_window), "destroy", G_CALLBACK (main_window_destroy), NULL);
	gtk_window_set_title(GTK_WINDOW(main_window), "Vrr!");

	gtk_widget_show( main_vbox = gtk_vbox_new(0, 0) );
	gtk_widget_show( menubox = gtk_vbox_new(0, 0) );
	gtk_widget_show( toolbox = gtk_vbox_new(0, 0) );

	gtk_window_add_accel_group( GTK_WINDOW( main_window ), get_command_accel_group());
	gtk_box_pack_start(GTK_BOX(main_vbox), menubox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(main_vbox), toolbox, TRUE, TRUE, 0);
	gtk_container_add(GTK_CONTAINER (main_window), main_vbox);

	main_window_refresh_menu();
	main_window_refresh_toolbar();

	gtk_widget_show( main_window );
}
