#ifndef _GUI_VIEW_SETTINGS_
#define _GUI_VIEW_SETTINGS_

/**
  \file viewsettings.h
  Functions for setting view's display: zoom, value, rotation...
*/
#include "lib/lib.h"
#include <gtk/gtk.h>
#include "main.h"

/**
 Struct which handles view's setting window.
*/
struct view_settings{
	GtkWidget *window;	/**< pointer to window of view's settings */
	GtkObject *spin_zoom_adj;	/**< adjustment for zoom */
	GtkObject *spin_value_adj;	/**< adjustment for value */
	GtkObject *spin_rotation_adj;	/**< adjustment for rotation */
	GtkWidget *spin_zoom;		/**< spinner button for zoom */
	GtkWidget *spin_value;		/**< spinner button for value */
	GtkWidget *spin_rotation;	/**< spinner button for rotation */
	struct view *lw;	/**< pointer to parent local window */
	int *zoom;			/**< zoom of the related drawing area */
	int *value;			/**< value of the related drawing area */
	int *rotation;			/** rotation of the related drawing area (in degrees) */
};

/**
 Creates view settings window.
 \param lw parent local window
 \returns data for newly created window
*/
struct view_settings *create_view_settings(struct view *lw);

#endif
