#define LOCAL_DEBUG

#include "lib/lib.h"
#include "import/import.h"
#include "kernel/kernel.h"
#include <string.h>


/*
 * TODO:
 *  - sipky u car
 *  - tloustka cary
 *  - vzor car
 *  - barvy
 *  - vyplne
 *  - !splines!
 *  - velikost fontu
 *  - ruzne typy markeru
 *
 * optional:
 *  - negenerovat vse pres mouseclicky ale obcas davat zavislosti (???)
 */

static FILE *input;
static uns line;
static char *obj_name;

#define BUF_SIZE 256
#define GETS() do { s = fgets(buf, sizeof(buf), input); line++; if (!s) return 0; DBG("[%d]<<< %s", line, s); } while(0)
#define SCAN(fmt,n,...) do { if (sscanf(s, (fmt), __VA_ARGS__) != (n)) return 0; } while(0)
#define CMP(str) (strcmp(s, (str)) == 0)

#define PT2MM (25.4/72.27)

static int scan_header(void)
{
	char buf[BUF_SIZE];
	int i;
	char *s;

	GETS();
	if (!CMP("%!PS-Adobe-2.0 EPSF-1.2\n"))
		return 0;

	GETS();
	if (!CMP("%%Creator: Ipe 5.0\n"))
		return 0;

	/* Skip the header definitions */
	for (i=0; i<16; i++) {
		GETS();
	}

	/* Skip textboxes, if any */
	do {
		GETS();
	} while (CMP("%%\\put"));

	i = 118;
	DBG("Skipping %d lines of header\n", i);
	while (i--) {
		GETS();
	}
	return 1;
}

static int load_line(void)
{
	int dash_mask;
	int points;
	char buf[BUF_SIZE];
	char *s;
	int arr_dir = 0, arr_type = 0;
	int i;

	DBG("Loading line...\n");
	obj_name = "Line";

	GETS();
	SCAN("%% ss %d\n", 1, &dash_mask);
	DBG("Got dashmask 0x%x\n", dash_mask);
	GETS();		// skip line

	GETS();
	if (strstr(s, "% ar") == s) {
		SCAN("%% ar %d %d\n", 2, &arr_dir, &arr_type);
		DBG("Got arrow, dir=%d type=%d\n", arr_dir, arr_type);
		GETS();
	}

	while (*s && *s != '%')
		s++;
	SCAN("%% # %d\n", 1, &points);
	DBG("Got numpoints=%d\n", points);

	real pntx[points];
	real pnty[points];
	real dreal;
	int dint;

	if (arr_dir & 1) {
		GETS();
		SCAN("%f %f %d %f %f", 5, pntx, pnty, &dint, &dreal, &dreal);
	}
	else {
		GETS();
		SCAN("%f %f", 2, pntx, pnty);
	}
	DBG("Got first coords [%f, %f]\n", pntx[0], pnty[0]);
	for (i=1; i < points-1; i++) {
		GETS();
		SCAN("%f %f", 2, pntx+i, pnty+i);
		DBG("Got coords [%f, %f]\n", pntx[i], pnty[i]);
	}
	if (arr_dir & 2) {
		GETS();
		SCAN("%f %f %d %f %f", 5, pntx+points-1, pnty+points-1, &dint, &dreal, &dreal);
	}
	else {
		GETS();
		SCAN("%f %f", 2, pntx+i, pnty+i);
	}
	DBG("Got last coords [%f, %f]\n", pntx[i], pnty[i]);

	GETS();
	if (CMP("cl % cl\n")) {
		DBG("Path is closed\n");
		GETS();
	}

	real fr, fg, fb;

	if (strstr(buf, "% fic") == buf) {
		GETS();
		SCAN("%% fic %f %f %f", 3, &fr, &fg, &fb);
		DBG("Got fill color (rgb) %f %f %f\n", fr, fg, fb);
		GETS();
	}

	real lr, lg, lb, gr;

	if (CMP("% sk\n")) {
		GETS();
		SCAN("%f", 1, &gr);
		DBG("Got gray stroke %f\n", gr);
	}
	else if (CMP("% skc\n")) {
		GETS();
		SCAN("%f %f %f", 3, &lr, &lg, &lb);
		DBG("Got color stroke (rgb) %f %f %f\n", lr, lg, lb);
	}
	else if (CMP("% fi\n")) {
		GETS();
		SCAN("%f", 1, &gr);
		DBG("Got gray fill %f\n", gr);
	}
	else if (CMP("% fi 0\n")) {
		/* empty fill, do nothing */
	}
	else
		return 0;

	GETS();		// skip line

	for (i=0; i<points-1; i++)
		go_link(&go_segment_new(hanger_new_mc_xy(PT2MM * pntx[i], PT2MM * pnty[i]), hanger_new_mc_xy(PT2MM * pntx[i+1], PT2MM * pnty[i+1]))->go,
				&trans_tlo->tlg->group, NULL);

	return 1;
}

static int load_mark(void)
{
	char buf[BUF_SIZE], *s;

	DBG("Loading mark...\n");
	obj_name = "Mark";

	real cr, cg, cb, gr;

	GETS();
	if (CMP("% sk\n")) {
		GETS();
		SCAN("%f sg", 1, &gr);
		DBG("Got gray stroke %f\n", cg);
	}
	else if (CMP("% skc\n")) {
		GETS();
		SCAN("%f %f %f", 3, &cr, &cg, &cb);
		DBG("Got color stroke (rgb) %f %f %f\n", cr, cg, cb);
	}
	else
		return 0;

	int mark_type;

	GETS();
	SCAN("%% ty %d", 1, &mark_type);
	DBG("Got mark type %d\n", mark_type);

	GETS();		// % sz
	GETS();		// 2
	GETS();		// % xy

	real x, y;

	GETS();
	SCAN("%f %f", 2, &x, &y);
	DBG("Got mark position [%f,%f]\n", x, y);

	GETS();		// % End

	go_link(&go_point_new(hanger_new_mc_xy(PT2MM * x, PT2MM * y))->go, &trans_tlo->tlg->group, NULL);

	return 1;
}

static int load_segments(void)
{
	char buf[BUF_SIZE], *s;

	DBG("Loading segments...\n");
	obj_name = "Segments";

	int dash_mask;

	GETS();
	SCAN("%% ss %d", 1, &dash_mask);
	DBG("Got dash_mask=0x%x\n", dash_mask);

	GETS();		// skip

	int points;

	GETS();
	SCAN("%% # %d", 1, &points);
	DBG("Got %d points\n", points);
	real pntx[points], pnty[points];
	char mode[points];
	for (int i=0; i<points; i++) {
		GETS();
		SCAN("%f %f %c", 3, pntx+i, pnty+i, mode+i);
		DBG("Got coords [%f,%f] of mode '%c'\n", pntx[i], pnty[i], mode[i]);
	}

	real gr, cr, cg, cb;
	real fgr, fcr, fcg, fcb;

	GETS();
	if (CMP("% fi\n")) {
		GETS();
		SCAN("%f", 1, &fgr);
		DBG("Got gray fill %f\n", fgr);
		GETS();
	}
	else if (CMP("% fic\n")) {
		GETS();
		SCAN("%f %f %f", 3, &fcr, &fcg, &fcb);
		DBG("Got color fill (rgb) %f %f %f\n", fcr, fcg, fcb);
		GETS();
	}

	if (CMP("% sk\n")) {
		GETS();
		SCAN("%f", 1, &gr);
		DBG("Got gray stroke %f\n", gr);
	}
	else if (CMP("% skc\n")) {
		GETS();
		SCAN("%f %f %f", 3, &cr, &cg, &cb);
		DBG("Got color stroke %f %f %f\n", cr, cg, cb);
	}
	else
		return 0;

	struct geom_point start;
	for (int i=1; i<points; i++) {

		if (mode[i] == 'N') {
			start.x = PT2MM * pntx[i];
			start.y = PT2MM * pnty[i];
			continue;
		}

		go_link(&go_segment_new(hanger_new_mc_xy(PT2MM * pntx[i-1], PT2MM * pnty[i-1]), hanger_new_mc_xy(PT2MM * pntx[i], PT2MM * pnty[i]))->go,
				&trans_tlo->tlg->group, NULL);

		if (mode[i] == 'C')
			go_link(&go_segment_new(hanger_new_mc_xy(PT2MM * pntx[i], PT2MM * pnty[i]), hanger_new_mc_xy(start.x, start.y))->go,
					&trans_tlo->tlg->group, NULL);
	}

	return 1;
}

static int load_circle(void)
{
	char buf[BUF_SIZE], *s;

	DBG("Loading circle...\n");
	obj_name = "Circle";

	int dash_mask;

	GETS();
	SCAN("%% ss %d", 1, &dash_mask);
	DBG("Got dashmask=0x%x\n", dash_mask);

	GETS();		// skip
	GETS();		// np % xy

	real x, y, r;

	GETS();
	SCAN("%f %f", 2, &x, &y);
	DBG("Got center coord [%f,%f]\n", x, y);

	GETS();
	SCAN("%f", 1, &r);
	DBG("Got radius %f\n", r);

	real gr, cr, cg, cb;
	real fgr, fcr, fcg, fcb;

	GETS();
	if (CMP("% fi\n")) {
		GETS();
		SCAN("%f", 1, &fgr);
		DBG("Got gray fill %f\n", fgr);
		GETS();
	}
	else if (CMP("% fic\n")) {
		GETS();
		SCAN("%f %f %f", 3, &fcr, &fcg, &fcb);
		DBG("Got color fill (rgb) %f %f %f\n", fcr, fcg, fcb);
		GETS();
	}

	if (CMP("% sk\n")) {
		GETS();
		SCAN("%f", 1, &gr);
		DBG("Got gray stroke %f\n", gr);
	}
	else if (CMP("% skc\n")) {
		GETS();
		SCAN("%f %f %f", 3, &cr, &cg, &cb);
		DBG("Got color stroke %f %f %f\n", cr, cg, cb);
	}
	else
		return 0;

	go_link(&go_elarc_new_xyr(hanger_new_mc_xy(PT2MM * x, PT2MM * y), 0, PT2MM * r, PT2MM * r, 0, 2*R_PI, GEOM_CONIC_ARC_START_ENTIRE)->go,
			&trans_tlo->tlg->group, NULL);

	return 1;
}

static int load_arc(void)
{
	char buf[BUF_SIZE], *s;

	DBG("Loading arc...\n");
	obj_name = "Arc";

	int dash_mask;

	GETS();
	SCAN("%% ss %d", 1, &dash_mask);
	DBG("Got dashmask=0x%x\n", dash_mask);

	GETS();		// skip
	GETS();		// % xy

	real x, y, r, sa, ea;

	GETS();
	SCAN("%f %f", 2, &x, &y);
	DBG("Got center coords [%f,%f]\n", x, y);

	GETS();
	SCAN("%f", 1, &r);
	DBG("Got radius=%f\n", r);

	GETS();
	SCAN("%f %f", 2, &sa, &ea);
	DBG("Got startangle=%f endangle=%f\n", sa, ea);

	real gr, cr, cg, cb;
	real fgr, fcr, fcg, fcb;

	GETS();
	if (CMP("% fi\n")) {
		GETS();
		SCAN("%f", 1, &fgr);
		DBG("Got gray fill %f\n", fgr);
		GETS();
	}
	else if (CMP("% fic\n")) {
		GETS();
		SCAN("%f %f %f", 3, &fcr, &fcg, &fcb);
		DBG("Got color fill (rgb) %f %f %f\n", fcr, fcg, fcb);
		GETS();
	}

	if (CMP("% sk\n")) {
		GETS();
		SCAN("%f", 1, &gr);
		DBG("Got gray stroke %f\n", gr);
	}
	else if (CMP("% skc\n")) {
		GETS();
		SCAN("%f %f %f", 3, &cr, &cg, &cb);
		DBG("Got color stroke %f %f %f\n", cr, cg, cb);
	}
	else
		return 0;

	go_link(&go_elarc_new_xyr(hanger_new_mc_xy(PT2MM * x, PT2MM * y), 0, PT2MM * r, PT2MM * r,
			R_PI * (sa<0 ? sa+360 : sa) / 180, R_PI * (ea-sa) / 180, GEOM_CONIC_ARC_START_ENTIRE)->go, &trans_tlo->tlg->group, NULL);

	return 1;
}

static int load_text(void)
{
	char buf[BUF_SIZE], *s;

	DBG("Loading text...\n");
	obj_name = "Text";

	real x, y;

	GETS();
	SCAN("%% xy %f %f", 2, &x, &y);
	DBG("Got coords [%f,%f]\n", x, y);

	real gr, cr, cg, cb;

	GETS();
	if (strstr(s, "% sk ") == s) {
		SCAN("%% sk %f", 1, &gr);
		DBG("Got gray stroke %f\n", gr);
	}
	else if (strstr(s, "% skc ") == s) {
		SCAN("%% skc %f %f %f", 3, &cr, &cg, &cb);
		DBG("Got color stroke (rgb) %f %f %f\n", cr, cg, cb);
	}
	else
		return 0;

	int font_type;
	real font_size;

	GETS();
	SCAN("%% f %d %f", 2, &font_type, &font_size);
	DBG("Got font_type=%d font_size=%f\n", font_type, font_size);
	/*
	 * font type:
	 * 0	roman
	 * 1	italic
	 * 2	bold
	 * 3	math
	 */

	char txt[BUF_SIZE+10];

	GETS();
	if (strstr(s, "% s ") != s)
		return 0;

	DBG("Adding prolog...");
	txt[0] = 0;
	switch (font_type) {
	case 0:
		break;
	case 1:
		strcpy(txt, "\\it ");
		break;
	case 2:
		strcpy(txt, "\\bf ");
		break;
	case 3:
		strcpy(txt, "$");
		break;
	default:
		return 0;
	}
	DBG("'%s'\n", txt);
	strcat(txt, s+4);
	s = txt;
	while (*s && *s != '\n')
		s++;
	if (font_type == 3)
		*s++ = '$';
	*s = 0;
	DBG("Got text %s\n", txt);

	GETS();		// skip

	go_link(&go_tex_text_new(hanger_new_mc_xy(PT2MM * x, PT2MM * y), 0, 0, 0, 0,
			string_lookup(txt))->go, &trans_tlo->tlg->group, NULL);

	return 1;
}

static int load_spline(void)
{
	char buf[BUF_SIZE], *s;

	DBG("Loading spline...\n");
	obj_name = "Spline";

	int dash_mask;

	GETS();
	SCAN("%% ss %d", 1, &dash_mask);
	DBG("Got dash_mask=0x%x\n", dash_mask);

	GETS();		// skip

	int points;

	GETS();
	SCAN("np %% # %d", 1, &points);
	DBG("Got points=%d\n", points);

	real x, y;

	for (int i=0; i<points; i++) {
		GETS();
		SCAN("%f %f", 2, &x, &y);
		DBG("Got coords [%f,%f]\n", x, y);
	}
	GETS();		// skip xspl

	real gr, cr, cg, cb;
	real fgr, fcr, fcg, fcb;

	GETS();
	if (CMP("% fi\n")) {
		GETS();
		SCAN("%f", 1, &fgr);
		DBG("Got gray fill %f\n", fgr);
		GETS();
	}
	else if (CMP("% fic\n")) {
		GETS();
		SCAN("%f %f %f", 3, &fcr, &fcg, &fcb);
		DBG("Got color fill (rgb) %f %f %f\n", fcr, fcg, fcb);
		GETS();
	}

	if (CMP("% sk\n")) {
		GETS();
		SCAN("%f", 1, &gr);
		DBG("Got gray stroke %f\n", gr);
		GETS();
	}
	else if (CMP("% skc\n")) {
		GETS();
		SCAN("%f %f %f", 3, &cr, &cg, &cb);
		DBG("Got color stroke %f %f %f\n", cr, cg, cb);
		GETS();
	}

	return 1;
}

static int scan_body(void)
{
	char buf[BUF_SIZE], *s;
	int r;

	for (;;) {
		s = fgets(buf, sizeof(buf), input);
		line++;
		if (!s)
			break;
		DBG("[%d]<<< %s", line, s);

		if (CMP("% Line\n"))
			r = load_line();
		else if (CMP("% Mark\n"))
			r = load_mark();
		else if (CMP("% Segments\n"))
			r = load_segments();
		else if (CMP("% Circle\n"))
			r = load_circle();
		else if (CMP("% Arc\n"))
			r = load_arc();
		else if (CMP("% Text\n"))
			r = load_text();
		else if (CMP("% Spline\n"))
			r = load_spline();

		if (!r)
			return 0;
	}
	return 1;
}

int import_tlo_ipe5(const char *filename, struct obj_tlo *out)
{
	char err_msg[TRANS_ERR_SIZE];
	line = 0;

	TRANS_BEGIN_MAIN(out, "IPE image", err_msg)
		input = fopen(filename, "r");
		if (!input)
			trans_fail("Error opening file '%s'\n", filename);
		if (!scan_header())
			trans_fail("Invalid header, error on line %d\n", line);
		if (!scan_body())
			trans_fail("Invalid %s object, error on line %d\n", obj_name, line);
	TRANS_FAILED
		err(err_msg);
		return -1;
	TRANS_END
	return 0;
}

int import_ipe5(FILE *in)
{
	input = in;
	line = 0;

	if (!scan_header()) {
		err("Invalid header, error on line %d\n", line);
		return -1;
	}
	if (!scan_body()) {
		err("Invalid %s object, error on line %d\n", obj_name, line);
		return -1;
	}
	return 0;
}
