#include "kernel/internal.h"

#define GO_ID GROUP

struct hanger_info hanger_go_group_tlg_info[] = {
	{ NULL, QT_POINT, 0, go_group_info, OFFSETOF(struct hanger_smart, q), NULL, 1 },
	{ NULL, QT_CURVE, 0, go_group_info, OFFSETOF(struct hanger_smart, q), NULL, 1 },
};

void go_group_recompute(struct go_group *g UNUSED)
{
}

void go_group_transform(struct go_group *g, struct geom_transform *t UNUSED)
{
	go_group_recompute(g);
}

/*int go_group_bbox(struct go_group *group, struct geom_rectangle *bbox)
{
	struct go *go;
	const struct geom_rectangle *r;
	geom_rectangle_set_empty(bbox);
	WALK_GROUP_GO(group, go)
		if((r = go_get_expand_bbox(trans_tlo, go)))
			geom_rectangle_merge(r, bbox, bbox);
	return 1;
}*/

struct go_group *go_group_new(void)
{
	struct go_group *g = xmalloc_zero(sizeof(struct go_group));
	group_init(g, GOST_GROUP);
	return g;
}

struct go_info go_group_info[GOST_GROUP_MAX] = {
	[GOST_GROUP] = { NULL, 0, 0, 0, NULL, -1, -1, -1, -1, 0, 0, NULL, ET_NONE, &o_prop_name },
	[GOST_GROUP_TLG] = { NULL, 0, 0, OFFSETOF(struct go_tlg, mc), hanger_go_group_tlg_info, -1, -1, -1, -1, 0, 0, NULL, ET_NONE, &o_prop_name },
	[GOST_GROUP_TEMP] = { NULL, 0, 0, OFFSETOF(struct go_tlg, mc), NULL, -1, -1, -1, -1, 0, 0, NULL, ET_NONE, &o_prop_name },
	[GOST_GROUP_ZOMBIE] = { NULL, 0, 0, OFFSETOF(struct go_tlg, mc), NULL, -1, -1, -1, -1, 0, 0, NULL, ET_NONE, &o_prop_name },
};


void go_group_init(void)
{
//	PINIT(go_group) ();
	go_group_info[GOST_GROUP].name = string_lookup_ref("group");
	go_group_info[GOST_GROUP_TLG].name = string_lookup_ref("top-level-group");
	go_group_info[GOST_GROUP_TEMP].name = string_lookup_ref("temp-group");
	go_group_info[GOST_GROUP_ZOMBIE].name = string_lookup_ref("zombie-group");
	string_go_type[GOT_GROUP] = string_lookup_ref("group");
	hanger_go_group_tlg_info[QT_POINT].name = string_lookup_ref("mouse-click-position");
	hanger_go_group_tlg_info[QT_CURVE].name = string_lookup_ref("mouse-click-curve");
}

void go_group_finish(void)
{
//	PFINISH(go_group) ();
	string_unref(go_group_info[GOST_GROUP].name);
	string_unref(go_group_info[GOST_GROUP_TLG].name);
	string_unref(go_group_info[GOST_GROUP_TEMP].name);
	string_unref(go_group_info[GOST_GROUP_ZOMBIE].name);
	string_unref(hanger_go_group_tlg_info[QT_POINT].name);
	string_unref(hanger_go_group_tlg_info[QT_CURVE].name);
}

