#include "kernel/internal.h"

#define GO_ID POINT
#define GO_SUBID POINT

PROP_ALL_REHANG(coordinate, o_prop_name, geom.point, 0, "Hanger of point must be a mouse click to change position.", 0)

PROP_VIRTUAL(&PSTRUCT(coordinate_x), string_coordinate_x->text, &PSTRUCT(coordinate_y), string_coordinate_y->text)

INFO_ANCHOR_1("point", QT_POINT, LT_AFFINITY)
INFO_HANGER_1("point", QT_POINT, geom.point, NULL, LT_AFFINITY)
INFO_GO_1("point",
		POINT, "point", 1, -1, -1, -1, 0, 1, ET_NONE, coordinate_x)

void go_point_recompute(struct go_point *p)
{
	p->geom.point = hanger_get_position(p->a->h);
}

void go_point_transform(struct go_point *p, struct geom_transform *t UNUSED)
{
	go_point_recompute(p);
}

int go_point_bbox(struct go_point *p, struct geom_rectangle *r)
{
	*r = (struct geom_rectangle){ p->geom.point, p->geom.point };
	return 1;
}

struct go_point *go_point_new(struct hanger *h)
{
	struct go_point *p = xmalloc_zero(sizeof(struct go_point));
	go_init(&p->go, GOT_POINT, GOST_POINT, h);
	p->unit_coordinate_x = p->unit_coordinate_y = PROP_UNIT_MAX;
	return p;
}

