#ifndef _KERNEL_GUILE_ACCESS_
#define _KERNEL_GUILE_ACCESS_

SCHEME static SHANGER mc_new(SREAL x, SREAL y) STRANS
	{ return hanger_new_mc_xy(x, y); }

SCHEME static SINT font_load(SSTRINGC fname)
	{ return font_load_file(fname); }

SCHEME static SSTRINGC font_file_name(SINT fnid)
{ return font_filename(fnid); }


SCHEME static SO_obj_tlo get_trans_tlo(void) STRANS
{ return (trans_tlo); }

SCHEME static SHANGER anchor_get_hanger(SANCHOR anchor) { return (anchor -> h); }

SCHEME static SSYMBOLS anchor_get_class_name(SANCHOR anchor) { return (anchor -> info -> name); }
SCHEME static SSYMBOLS hanger_get_class_name(SHANGER hanger) { return (hanger -> info -> name); }

SCHEME static SREAL hanger_get_pos_x(SHANGER hanger) { return (hanger_get_position (hanger) . x); }
SCHEME static SREAL hanger_get_pos_y(SHANGER hanger) { return (hanger_get_position (hanger) . y); }

// FIXME: Tato funkce musi bezet ve spravne transakci (STRANS nebo SMETATRANS podle kind o)!!!
static void prop_set_forte(struct o *o, const char *name, uns type, uns subtype, uns check, prop_value value)
{
	string key = string_lookup(name);
	struct prop *p = prop_find(o, key);

	if(!p)
		prop_create(o, key, type, subtype, PROP_UNIT_MAX, value);
	else if((p->type == type) && (p->subtype == subtype || !check))
		prop_set(o, key, value);
	else if(!(p->flags && PTF_VIRTUAL))
	{
		prop_delete(o, p);
		prop_create(o, key, type, subtype, PROP_UNIT_MAX, value);
	}
	else
		trans_fail("Cannot set property: collision with virtual property with different type or subtype");
}

SCHEME static SVOID prop_uns_set_forte(SO_o o, SSYMBOLC name, SUNS type, SUNS subtype, SBOOL check, SUNS value) SOTRANS(0)
{ prop_set_forte (o, name, type, subtype, check, (prop_value){.u=value}); }

SCHEME static SVOID prop_string_set_forte(SO_o o, SSYMBOLC name, SUNS type, SUNS subtype, SBOOL check, SSTRINGC value) SOTRANS(0)
{ prop_set_forte (o, name, type, subtype, check, (prop_value){.s=string_lookup(value)}); }

SCHEME static SVOID prop_real_set_forte(SO_o o, SSYMBOLC name, SUNS type, SUNS subtype, SBOOL check, SREAL value) SOTRANS(0)
{ prop_set_forte (o, name, type, subtype, check, (prop_value){.r=value}); }

SCHEME static SVOID property_uns_set(SO_o o, SSYMBOLC name, SUNS value) SOTRANS(0)
{ prop_set_forte (o, name, PT_UNS, PTU_UNSPECIFIED, 1, (prop_value){.u=value}); }

SCHEME static SVOID property_string_set(SO_o o, SSYMBOLC name, SSTRINGC value) SOTRANS(0)
{ prop_set_forte (o, name, PT_STRING, PTS_UNSPECIFIED, 0, (prop_value){.s=string_lookup(value)}); }

SCHEME static SVOID property_real_set(SO_o o, SSYMBOLC name, SREAL value) SOTRANS(0)
{ prop_set_forte (o, name, PT_REAL, PTR_UNSPECIFIED, 0, (prop_value){.r = value}); }



/*
 * TRANSFORMATIONS
 */

SCHEME static SVOID move_selected(SO_go_group group, SREAL x, SREAL y) STRANS
{
  struct geom_transform2 t;
  if(geom_transform2_set_move(&t, x, y))
	  trans_fail("Numeric overflow");
  tsort_selected_transform(group, &t);
}

SCHEME static SVOID rotate_selected(SO_go_group group, SREAL x, SREAL y, SREAL angle) STRANS
{
  struct geom_transform2 t;
  if(geom_transform2_set_rotate_center(&t, x, y, angle))
	  trans_fail("Numeric overflow");
  tsort_selected_transform(group, &t);
}

SCHEME static SVOID scale_selected(SO_go_group group, SREAL cx, SREAL cy, SREAL sx, SREAL sy) STRANS
{
  struct geom_transform2 t;
  if(geom_transform2_set_scale_center(&t, cx, cy, sx, sy))
	  trans_fail("Numeric overflow");
  tsort_selected_transform(group, &t);
}

SCHEME static SUNS proxy2ptr(SO_go go) { return (((uns) go) >> 2); }


/*
 * Exports and imports
 */

SCHEME static SVOID save_as_ps(SO_obj_doc doc, SSTRINGC file_name, SREAL pwidth, SREAL pheight, SINT fit_to_page, SINT without_fonts)
{
	FILE *f = fopen(file_name, "w");
	if(!f)
	{
		msg("Cannot open file.\n");
		return;
	}

	export_ps(doc, f, pwidth, pheight, fit_to_page, without_fonts);
	fclose(f);
}

SCHEME static SVOID save_as_eps(SO_obj_tlo tlo, SSTRINGC file_name, SINT without_fonts)
{
	FILE *f = fopen(file_name, "w");
	if(!f)
	{
		msg("Cannot open file.\n");
		return;
	}

	export_eps(tlo, f, without_fonts);
	fclose(f);
}

SCHEME static SVOID save_as_pdf(SO_obj_doc doc, SSTRINGC file_name, SINT without_fonts, SINT compress_level)
{
	char buf[TRANS_ERR_SIZE];
	FILE *f = fopen(file_name, "w");
	if(!f)
	{
		msg("Cannot open file.\n");
		return;
	}

	TRANS_BEGIN_ANONYMOUS(buf)
		export_pdf(doc, f, without_fonts, compress_level);
	TRANS_FAILED
		msg("Cannot export into PDF: %s\n", buf);
	TRANS_END

	fclose(f);
}

SCHEME static SVOID save_as_svg(SO_obj_tlo tlo, SSTRINGC file_name)
{
	int result;
	export_svg(tlo, file_name, &result);
	if(result != 0)
		msg("export_svg return %d\n", result);
}


/*
 * Miscellaneous
 */

SCHEME static SUNS vrr_is_with_gui(void) { return vrr_with_gui; }

/*
 * Debugging
 */

SCHEME static SO_go go_link_named(SO_go go, SO_go_group group, SSTRINGC name) STRANS
	{ go_link(go, group, NULL); o_set_name(go2o(go), name); return go; }

SCHEME static SO_go go_relink_first(SO_go go, SO_go_group group) STRANS
	{ go_relink(go, group, NULL); return go; }

SCHEME static SVOID walk_visualisation_test(SO_go_group gr, SREAL x1, SREAL y1, SREAL x2, SREAL y2)
{
	struct go_group *ow;
	struct go *g;
	struct geom_rectangle bbox = { { x1, y1 }, { x2, y2 } };
	struct obj_tlo *t = go_get_tlo(&gr->go);
	WALK_GROUP_SMART_BBOX(t, gr, &bbox, g, ow,
			msg("pre: %s at %p\n", go_lookup_name(&ow->go), ow),
			msg("owner: %s at %p, ", go_lookup_name(&ow->go), ow); msg("go: %s at %p\n", go_lookup_name(g), g),
			msg("post: %s at %p\n", go_lookup_name(&ow->go), ow));
}

SCHEME static inline SO_o ptr2o(SSTRINGC c)
{
	struct o *o;
	if(c && c[0] == '0' && c[1] == 'x')
	{
		sscanf(c, "%p", &o);
		if(o->kind == T_OBJ || o->kind == T_GO)
			return o;
	}
	msg("ptr2o fail: Invalid pointer %s\n", c);
	return NULL;
}

SCHEME static inline SHANGER ptr2h(SSTRINGC c)
{
	struct hanger *h;
	if(c && c[0] == '0' && c[1] == 'x')
	{
		sscanf(c, "%p", &h);
		return h;
	}
	msg("ptr2h fail: Invalid pointer %s\n", c);
	return NULL;
}

SCHEME static inline SANCHOR ptr2a(SSTRINGC c)
{
	struct anchor *a;
	if(c && c[0] == '0' && c[1] == 'x')
	{
		sscanf(c, "%p", &a);
		return a;
	}
	msg("ptr2a fail: Invalid pointer %s\n", c);
	return NULL;
}

SCHEME static SVOID undo_bug(void)
{
	char buf1[TRANS_ERR_SIZE], buf2[TRANS_ERR_SIZE];
	struct obj_doc *doc;
	
	TRANS_BEGIN_MAIN(tlo_universum, "Findind bug in undo.", buf1)
		doc = doc_new_named_link("doc bug");
		TRANS_BEGIN(buf2)
			trans_fail("Failing subtrans.");
		TRANS_FAILED
			ASSERT(doc->obj.father == obj_universum);
		TRANS_END
	TRANS_FAILED
		BUG();
	TRANS_END
	ASSERT(doc->obj.father == obj_universum);
}

SCHEME SVOID trans_test(void);

SCHEME SVOID pattern_test(void);

#endif
