/** @file
 *
 * 	VRR kernel - Main header.
 *
 * FIXME: Uklitit tento kos.
 */

#ifndef _KERNEL_KERNEL_H_
#define _KERNEL_KERNEL_H_

#include "lib/lib.h"
#include <setjmp.h>
#include <limits.h>
#include "lib/slists.h"
#include "lib/clists.h"
#include "lib/flists.h"
#include "geomlib/geomlib.h"
#include "kernel/scheme_def.h"
#include "kernel/strings.h"

struct o;
struct prop;

#include "kernel/trans.h"
#include "kernel/types.h"
#include "kernel/property.h"

#ifndef DEBUG_REF_O
#define DEBUG_REF_O_ARGS
#else
#define DEBUG_REF_O_ARGS DEBUG_ARGS
#endif

void trans_begin_main(struct obj_tlo* t, const char *name, char* error_string, jmp_buf* jb);
void trans_begin_sub(char* error_string, jmp_buf* jb);
void trans_begin_anonymous(char* error_string, jmp_buf* jb);
void trans_end(void);

SCHEME SO_obj_tlo go_get_tlo(SO_go go);
static inline struct go_info* go_get_info(struct go* g)
	{ return &go_info[g->type][g->subtype]; }
static inline int hanger_is_smart(struct hanger *h)
	{ return h->info->go_offset == 0; }
static inline struct hanger_smart* hanger2smart(struct hanger *h)
	{ ASSERT(h && hanger_is_smart(h)); return (struct hanger_smart*)h; }
static inline clist* go_get_lhanger(struct go *go)
	{ int i = go_get_info(go)->hs_offset; return i ? SKIP_OFFSET(clist, go, i) : NULL; }
static inline struct hanger_smart* go_lhanger_get_first_hanger_smart(clist *l)
	{ return l->head.next == &l->head ? NULL : SKIP_BACK(struct hanger_smart, nhanger, l->head.next); }
static inline struct hanger_smart* go_lhanger_get_next_hanger_smart(clist *l, struct hanger_smart *hs)
	{ return hs->nhanger.next == &l->head ? NULL : SKIP_BACK(struct hanger_smart, nhanger, hs->nhanger.next); }


#include "kernel/functions.h"
#include "kernel/tsort.h"
#include "kernel/go.h"
#include "kernel/rtree.h"


#ifdef DEBUG_REF_O
#define obj_ref(s) obj_ref(s, __FILE__, __LINE__, __func__)
#define obj_unref(s) obj_unref(s, __FILE__, __LINE__, __func__)
#define go_ref(s) go_ref(s, __FILE__, __LINE__, __func__)
#define go_unref(s) go_unref(s, __FILE__, __LINE__, __func__)
#define o_ref(s) o_ref(s, __FILE__, __LINE__, __func__)
#define o_unref(s) o_unref(s, __FILE__, __LINE__, __func__)
#define hanger_ref(s) hanger_ref(s, __FILE__, __LINE__, __func__)
#define hanger_unref(s) hanger_unref(s, __FILE__, __LINE__, __func__)
#endif

struct expand_rtree
{
	int usage;
	struct geom_rtree_obj rtree;
	struct go *go;
};


void gl_misc_init(void);
void gl_trans_init(void);
void glt_kernel_init(void);
void glt_kernel_finish (void);
void gl_first_init(void);
void gl_last_init(void);
	

/** the user settings directory */
#define VRR_DIR				"/.vrr"
/** The global settings file */
#define GLOBAL_SETTINGS_FILE		"/settings"
/** Maximum volume of undo history FIXME: zvetsit konstantu */
#define MAX_UNDO_HISTORY_VOLUME_KB	 1

#endif
