(define count 3) ;250)

(define (rnd) (- (/ (random 8000) 100)  40))

(define (name-segment i j) (string-append "segment-" (number->string i) "-" (number->string j)))
(define (name-group i) (string-append "group-" (number->string i)))

(define (transaction tlo-go name fce) (trans-main (if (eq? (proxy-get-kind tlo-go) 'obj) tlo-go (go-get-tlo tlo-go)) fce (lambda x (write-line x)) name))

(define (group-tree group count sons)
	(define (for i)
		(go-link-named (go-group-new) (lookup (name-group (/ (- i (modulo i sons)) sons))) (name-group i))
		(if (< i count) (for (+ i 1)))
	)
	(transaction group "Making groups" (lambda ()
			(go-link-named (go-group-new) group (name-group 0))
			(for 1)
	))
)

(define (Kn tlo group count)
	(define (mc n) (if (< n count) (let ((h (vector-set! v n (mc-new (rnd) (rnd)))))(mc (+ n 1)))))
	(define v (make-vector count))
	(define (line i j) (let* (
				(l (go-link-named (go-segment-new (vector-ref v i) (vector-ref v j)) (group i j) (name-segment i j)))
			)
			(vector-set! v i (go-get-hanger l 1))
			(vector-set! v j (go-get-hanger l 2))
	))
	(define (for-in i j) (if (< j count) (let ((l (line i j))) (for-in i (+ j 1)))))
	(define (for-out i) (if (< i count) (let ((l (for-in i (+ i 1)))) (for-out (+ i 1)))))
	(transaction tlo "Making mouse clicks and segments" (lambda ()
			(mc 0)
			(for-out 0)
	))
)

(define (go-new go name)
	(go-link-named go (tlo-get-tlg (get-trans-tlo)) name)
	(go-select go)
;	(go-dump-all go)
	go
)

(define (big-test)
	(define (select-diagonal n) (if (> n 2) (select-diagonal (- n 1))) (go-select (lookup (name-segment (- n 2) (- n 1)))))

	(let* (
			(doc (make-doc "Document1"))
			(tlo (make-tlo doc "TLO1"))
			(tlo2 (make-tlo doc "TLO2"))
			(group (trans-main tlo2 (lambda () (go-link-named (go-group-new) (tlo-get-tlg tlo2) "group"))))
			(font (font-load "/usr/X11R6/lib/X11/fonts/URW/s050000l.pfb"))
		)

		(expand-ref tlo)
		(expand-ref tlo2)

		(trans-main obj-universum (lambda () (obj-select tlo)))
		(trans-main obj-universum (lambda () (obj-unselect-all)))

		(trans-main tlo (lambda ()
				(go-new (go-point-new (mc-new 1 2) ) "first-point")
				(go-new (go-segment-new (mc-new 1 2) (mc-new 2 1)) "first-segment")
				(go-new (go-bezier-new-cubic (mc-new 1 1) 1 (mc-new 1 2) 2 (mc-new 2 2) 3 (mc-new 2 1) 4) "first-cubic-bezier")
				(go-new (go-bezier-new-quadratic (mc-new 1 2) 1 (mc-new 2 1) 2 (mc-new 1 2) 1) "first-quadratic-bezier")
				(go-new (go-elarc-new-xyr (mc-new 1 2) 0.5 10 20 2 3 1) "first-elarc-xyr")
				(go-new (go-elarc-new-foci (mc-new 1 2) (mc-new 2 1) (mc-new 3 3) 2) "first-elarc-foci")
				(go-new (go-elarc-new-3small (mc-new 1 2) (mc-new 2 1) (mc-new 3 3) 4) "first-elarc-3small")
				(go-new (go-elarc-new-3ecc (mc-new 1 2) (mc-new 2 1) (mc-new 3 3) 1 .5 1) "first-elarc-3ecc")
				(go-new (go-elarc-new-xy1ecc (mc-new 1 2) (mc-new 2 1) 1 .5 2) "first-elarc-xy1ecc")
				(go-new (go-parametric-point-new (go-new (go-segment-new (mc-new 3 4) (mc-new 5 6)) "segment-parametric-point") 0.5) "first-parametric-point")
;				(go-new (go-text-new (mc-new 5 5) 1 2 3 4 "Hello world!" font 5) "first-text")
;				(go-new (go-tex-text-new (mc-new 5 5) 1 2 3 4 "$e^{i\pi}=-1$") "first-tex")
				(go-new (go-decorator-point-new (mc-new 1 2) 0 4 0) "first-decorator-point")

				(go-link-named (go-segment-new (mc-new 1 2) (mc-new 2 1)) (go-new (go-group-new) "first-group") "segment-in-group")
		))

		(trans-main tlo (lambda () (move-selected (tlo-get-tlg tlo) 10 20)))

		(undo tlo)(undo tlo)
		(redo tlo)(redo tlo)

		(group-tree (tlo-get-tlg tlo2) count 3)
		(Kn tlo2 (lambda (i j) (lookup (name-group j))) count)

		(trans-main tlo2 (lambda () (select-diagonal count)))
		(trans-main tlo2 (lambda () (move-selected (tlo-get-tlg tlo2) 10 20)))
		(trans-main tlo2 (lambda () (tlo-unselect-all-go)))
		(trans-main tlo2 (lambda () (select-diagonal count)))
		(trans-main tlo2 (lambda () (group-select-all-go (tlo-get-tlg tlo2))))
		(trans-main tlo2 (lambda () (group-unselect-all-go (tlo-get-tlg tlo2))))
		(trans-main tlo2 (lambda () (select-diagonal count)))
		(trans-main tlo2 (lambda () (group-unlink-selected-go (tlo-get-tlg tlo2))))

		(undo tlo2)(undo tlo2)(undo tlo2)(undo tlo2)(undo tlo2)(undo tlo2)
		(redo tlo2)(redo tlo2)(redo tlo2)(redo tlo2)(redo tlo2)(redo tlo2)

		(trans-main obj-universum (lambda () (obj-unlink tlo2)))
		(undo obj-universum)

		(trans-main tlo2 (lambda () (go-unlink (lookup (name-segment (- count 2) (- count 1))))))
		(trans-main tlo2 (lambda () (go-remove-rehang (lookup (name-segment (- count 3) (- count 2))))))
		(trans-main tlo2 (lambda () (go-select (lookup (name-group 1)))))
		(trans-main tlo2 (lambda () (group-remove-rehang-selected-go (lookup (name-group 0)))))
		(undo tlo2)(undo tlo2)(undo tlo2)(undo tlo2)

		(trans-main tlo2 (lambda () (go-select (lookup (name-group 1)))))
		(trans-main tlo2 (lambda () (go-relink-first (lookup (name-segment (- count 3) (- count 2))) group)))
		(trans-main tlo2 (lambda () (group-relink-selected-go (lookup (name-group 0)) group (lookup (name-segment (- count 3) (- count 2))))))
		(undo tlo2)(undo tlo2)(undo tlo2)

;		(walk-visualisation-test (tlo-get-tlg tlo2) -100 -100 100 100)
		(expand-unref tlo2)
		(expand-unref tlo)

; rehang test
  		(trans-main tlo2 (lambda () (anchor-rehang (go-get-anchor (lookup (name-segment 1 2)) 1) (go-get-hanger (lookup (name-segment 0 1)) 1))))
		(write-line "Next two lines must contain error message.")
  		(transaction tlo2 "anchor rehang fail" (lambda () (anchor-rehang (go-get-anchor (lookup (name-segment 0 1)) 1) (go-get-hanger (lookup (name-segment 1 2)) 1))))
;		(group-dump-subtree (tlo-get-tlg tlo2))
;		(tlo-dump-tsort tlo2)

		(save-as-ps doc "test.ps" 210 297 0 1)
		(save-as-eps tlo "test.eps" 0)
		(save-as-pdf doc "test.pdf" 0 1)
		(save-as-svg tlo "test.svg")
))

(big-test)
(finish)
;(write "\n\n\n\n\n\n\n\n\n")
