#ifndef _KERNEL_STRINGS_H_
#define _KERNEL_STRINGS_H_

/* This is used for debugging. */
#define DEBUG_ARGS , const char* file, int line, const char* fce
#ifndef DEBUG_REF_STRING
#define DEBUG_REF_STRING_ARGS
#else
#define DEBUG_REF_STRING_ARGS DEBUG_ARGS
#endif



/** Structure for referenced string  */
typedef struct string_entry
{
	struct string_entry *dead_next;
	uns ref_count;
	uns length;
	char text[1];
} *string;


/* Macro DEBUG_REF_STRING_ARGS is used for debugging. You can ignore it. */
string string_ref(string str DEBUG_REF_STRING_ARGS);
string string_unref(string str DEBUG_REF_STRING_ARGS);
string string_lookup(const char* str DEBUG_REF_STRING_ARGS);
string string_lookup_ref(const char* str DEBUG_REF_STRING_ARGS);
string string_find(const char* str);


/* Those strings are used as constants. */
#define NAMES_STRINGS \
	string_name, string_noname, \
	string_filename, string_file_unsaved, \
	string_coordinate_x, string_coordinate_y, \
	string_fill_color, string_stroke_color, string_stroke_width, string_stroke_cap, \
	string_text, string_font, string_font_size, \
	string_rpos_x, string_rpos_y, string_apos_x, string_apos_y, \
	string_maxhist

	
extern string NAMES_STRINGS,
	string_prop_type[],
	string_go_type[], string_obj_type[],
	string_quantity_type[],
	string_conic_type[], string_stroke_cap_type[];


/* This is used for debugging. */
#ifdef DEBUG_REF_STRING
#define string_ref(s) string_ref(s, __FILE__, __LINE__, __func__)
#define string_unref(s) string_unref(s, __FILE__, __LINE__, __func__)
#define string_lookup(s) string_lookup(s, __FILE__, __LINE__, __func__)
#define string_lookup_ref(s) string_lookup_ref(s, __FILE__, __LINE__, __func__)
#endif

#endif
