#ifndef _LIB_SMALLOC_H_
#define _LIB_SMALLOC_H_

#include "lib/clists.h"

#define FMALLOC_ALIGNMENT 128
#define SMALLOC_MAX 10

struct fmalloc_head
{
	clist lnode, lempty;
	uns size;
	void (*call_if_empty)(struct fmalloc_head*);
};

void fmalloc_init(struct fmalloc_head* f, uns size);
void fmalloc_finish(struct fmalloc_head* f);
void* fmalloc(struct fmalloc_head* f);
void ffree(void* p);

static inline uns fmalloc_is_empty(struct fmalloc_head* f) { return clist_empty(&f->lnode); }

extern struct fmalloc_head smalloc_table[SMALLOC_MAX];



void smalloc_init(void);
void smalloc_finish(void);

static inline void* smalloc(uns size)
{
	size = (size + sizeof(void*) - 1) / sizeof(void*);
	ASSERT(size && size < SMALLOC_MAX);
	return fmalloc(smalloc_table + size);
}

static inline void sfree(void *p) { ffree(p); }

static inline void fmalloc_sfree_head(struct fmalloc_head* f) { fmalloc_finish(f); sfree(f); }

#endif
