#include "vcl_internal.h"

#include <stdio.h>
#include <stdlib.h>


vdo_vtable *vcl_vt_solid_source;


static void
rasterize (struct vcl_solid_source * obj, struct vcl_pixbuf * pb,
	   struct vcl_rectangle *r, struct geom_transform2 *t, real lod)
{
  ASSERT (obj -> channels == pb -> channels);
  ASSERT (obj -> depth == pb -> depth);

  if ((obj -> channels * obj -> depth) <= 4)
    vcl_pixbuf_fill (pb, (u8 *) &(obj -> n));
  else
    vcl_pixbuf_fill (pb, obj -> p);
}

static void
get_bbox (struct vcl_solid_renderer * obj, struct vcl_rectangle *r)
{ vcl_rectangle_set_max (r); }


struct vcl_solid_source *
vcl_solid_source_new (uns channels, int alpha, uns depth, const void *values)
{
  ASSERT ((channels > 0) && (channels < 128));
  ASSERT ((depth == 1) || (depth == 2) || (depth == 4));
  ASSERT ((alpha > -2) && (alpha < channels));

  void *buff_ptr;
  struct vcl_solid_source * obj = xmalloc (sizeof (struct vcl_solid_source));
  vcl_object_init (obj, vcl_vt_solid_source);

  obj -> channels = channels;
  obj -> alpha = alpha;
  obj -> depth = depth;

  if (depth * channels > 4)
    buff_ptr = obj -> data . p = xmalloc (depth * channels);
  else
    buff_ptr = &(obj -> data . n);
  
  memcpy (buff_ptr, values, depth * channels);

  return (obj);
}


void
vcl_solid_source_main (void)
{
  vcl_vt_solid_source = vcl_class_new ("solid-fill");

  vcl_class_add_interface (vcl_vt_solid_source, vcl_if_source);
  vcl_class_add_method_li (vcl_mid_source_rasterize, rasterize);
}
