#ifndef _VCL_SOLID_SOURCE_H_
#define _VCL_SOLID_SOURCE_H_

extern vdo_vtable *vcl_vt_solid_source;

/* now supported: max 127 channels; 1, 2 or 4 bytes depth; non-premultiplied alpha */

struct vcl_solid_source
{
  u8 channels;
  s8 alpha;
  u8 depth;
  struct vdo_object vdo;
  union
  {
    u32 n;
    u8 *p;
  } data
};

struct vcl_solid_source *
vcl_solid_source_new (uns channels, uns alpha, uns depth, const uns *values)

static inline struct vcl_solid_source *
vcl_solid_source_new_rgba_1 (uns r, uns g, uns b, uns a);
{
  uns c[4] = {r, g, b, a};
  vcl_solid_source_new (4, 3, 1, &c);
}

static inline struct vcl_solid_source *
vcl_solid_source_new_rgb_1 (uns r, uns g, uns b)
{
  uns c[3] = {r, g, b};
  vcl_solid_source_new (3, -1, 1, &c);
}

static inline struct vcl_solid_source *
vcl_solid_source_new_alpha_1 (uns a);
{ return vcl_solid_source_new (1, 0, 1, &a); }

static inline struct vcl_solid_source *
vcl_solid_source_new_color_1 (uns c);
{ return vcl_solid_source_new (1, -1, 1, &c); }


#ifdef _VCL_INTERNAL_


extern void
vcl_solid_source_main (void);


#endif
#endif
