#include "vcl.h"

#include <stdio.h>
#include <stdlib.h>

#include <gtk/gtk.h>


GtkWidget *win, *vbox, *hbox, *entry, *b1, *b2;

struct vcl_canvas *can;
struct vcl_group *g1;
struct vcl_path *t1;
struct vcl_testrect *t2, *t3;

int state = 0;

static void
on_button_next_clicked (GtkButton *button UNUSED, gpointer user_data UNUSED)
{
  struct geom_bezier b;

  switch (state)
    {
    case 0:
      t1 = vcl_path_new (NULL, 0, 0, 0);

      geom_bezier_fill_linear_nonrational (&b, 0, 0, 1, 0);
      geom_path_add_tail (t1 -> used, &b);
      geom_bezier_fill_quadratic_nonrational (&b, 1, 0, 2, 1, 1, 1);
      geom_path_add_tail (t1 -> used, &b);
      geom_bezier_fill_cubic_nonrational (&b, 1, 1, 0.5, 1, 0.5, 2, 0, 2);
      geom_path_add_tail (t1 -> used, &b);
      geom_bezier_fill_quadratic_nonrational (&b, 0, 2, 0.5, 1, 0, 0);
      geom_path_add_tail (t1 -> used, &b);

      vcl_path_source_changed (t1);
      vcl_placement_add_child_on_top (can -> root, t1);
      break;
    case 1:
      vcl_item_move (t1, -2.0, 0);
      break;
    case 2:
      vcl_item_scale (t1, 1.5, 3.0, 0,0,0);
      break;
    case 3:
      vcl_item_rotate (t1, 1.8, 0,0,0);
      break;
    case 4:
      g1 = vcl_group_new ();
      t2 = vcl_testrect_new ();
      vcl_item_move (t2, 2.5, 1.0);
      vcl_placement_add_child_on_top (g1, t2);
      vcl_placement_add_child_on_top (can -> root, g1);
      break;
    case 5:
      vcl_item_scale (t2, 3.0, 3.0, 0,0,0);
      break;
    case 6:
      t3 = vcl_testrect_new ();
      vcl_placement_add_child_on_top (g1, t3);
      break;
      
    }
  if (state > 8)
    {
      if ((state & 3) == 0)
      	vcl_item_scale (t1, 2, 1, 0,0,0);
      else if ((state & 3) == 1)
	vcl_item_rotate (t1, 0.3, 0,0,0);
      else if ((state & 3) == 2)
	vcl_item_scale (t1, 0.5, 1, 0,0,0);
      else if ((state & 3) == 3)
	vcl_item_rotate (g1, 0.3, 0,0,0);
    }
  state ++;
}
                      
static void
on_button_close_clicked (GtkButton *button UNUSED, gpointer user_data UNUSED)
{
  gtk_exit (EXIT_SUCCESS);
}

static gboolean
on_win_delete_event (GtkWidget *widget UNUSED, GdkEvent *event UNUSED, gpointer user_data UNUSED)
{
  gtk_exit (EXIT_SUCCESS);
  return (TRUE);
}



static void
create_windows (void)
{
  win =  gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vbox = gtk_vbox_new (FALSE, 0);
  hbox = gtk_hbox_new (FALSE, 0);
  entry = gtk_entry_new_with_max_length (10);
  b1 = gtk_button_new_with_label ("Next");
  b2 = gtk_button_new_with_label ("Close");
  can = vcl_canvas_new (NULL);
  vcl_canvas_setup (can, VCL_CANVAS_REAL_UNITS | VCL_CANVAS_FLIP_Y, 0.5, 0.5, 10);

  gtk_box_pack_start (GTK_BOX (vbox), entry, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), b1, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), b2, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), can -> gtk -> widget, TRUE, TRUE, 0);

  gtk_container_add (GTK_CONTAINER (win), hbox);


  gtk_signal_connect (GTK_OBJECT (win), "delete_event",
                      GTK_SIGNAL_FUNC (on_win_delete_event), NULL);
  gtk_signal_connect (GTK_OBJECT (b1), "clicked",
                      GTK_SIGNAL_FUNC (on_button_next_clicked), NULL);
  gtk_signal_connect (GTK_OBJECT (b2), "clicked",
                      GTK_SIGNAL_FUNC (on_button_close_clicked), NULL);

  gtk_widget_show_all (win);
}

int
main (int argc, char ** argv)
{
  gtk_set_locale ();
  vcl_init ();
  gtk_init (&argc, &argv);
  create_windows ();
  gtk_main ();
}




