#include "vcl.h"

#include <stdio.h>
#include <stdlib.h>

#include <gtk/gtk.h>


GtkWidget *win, *vbox, *hbox, *entry, *b1, *b2;

struct vcl_canvas *can;
struct vcl_group *g1;
struct vcl_path *t1;
struct vcl_testrect *t2, *t3;

void * lear;
int state = 0;
int state2 = 0;
char objs [100];

static void
on_button_next_clicked (GtkButton *button UNUSED, gpointer user_data)
{
  if (state2 == 1)
      vcl_item_rotate (lear, 1.8, 0,0,0);
  else
    {
  if (objs [state] == 0)
    {
      objs [state] = 1;
      vcl_le_area_child_appeared_notification (VCL_LE_AREA (user_data), (void *) state);
    }
  else
    {
      objs [state] = 0;
      vcl_le_area_child_disappeared_notification (VCL_LE_AREA (user_data), (void *) state);
    }

      state = (state + 7) % 100;
    }
      state2 = (state2 + 1) % 2;
}
                      
static void
on_button_close_clicked (GtkButton *button UNUSED, gpointer user_data UNUSED)
{
  gtk_exit (EXIT_SUCCESS);
}

static gboolean
on_win_delete_event (GtkWidget *widget UNUSED, GdkEvent *event UNUSED, gpointer user_data UNUSED)
{
  gtk_exit (EXIT_SUCCESS);
  return (TRUE);
}

char objs [100];

static void
get_bbox_of_child_cb (void * child_id, struct vcl_le_area * questioner UNUSED, 
		      struct geom_rectangle *bbox, void * data UNUSED)
{
  int cid = (int) child_id;
  

  bbox -> ll . x = (cid % 10) * 1.8;
  bbox -> ll . y = (cid / 10) * 3.6;
  bbox -> ur . x =  bbox -> ll . x + 1;
  bbox -> ur . y =  bbox -> ll . y + 2;
}

static void *
expand_child_cb (void * child_id, struct vcl_le_area * questioner UNUSED, void * data UNUSED)
{
  int cid = (int) child_id;

  void * child = vcl_testrect_new ();
  vcl_item_move (child, (cid % 10) * 1.8, (cid / 10) * 3.6);

  return (child);
}

static void
get_children_in_bbox_cb (struct vcl_le_area * questioner, 
			 const struct geom_rectangle * bbox, void * data UNUSED)
{
  int i;
  for (i = 0; i < 100; i ++)
    if (objs [i])
      {
	struct geom_rectangle obj_bbox;
	get_bbox_of_child_cb ((void *) i, questioner, &obj_bbox, NULL);

	if (geom_rectangle_have_intersection (bbox, &obj_bbox))
	  vcl_le_area_answer_child_in_bbox (questioner, (void *)i);
      }
}

static void
create_windows (void)
{
  win =  gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vbox = gtk_vbox_new (FALSE, 0);
  hbox = gtk_hbox_new (FALSE, 0);
  entry = gtk_entry_new_with_max_length (10);
  b1 = gtk_button_new_with_label ("Next");
  b2 = gtk_button_new_with_label ("Close");

  lear = vcl_le_area_new (get_bbox_of_child_cb, NULL,
			  expand_child_cb, NULL,
			  get_children_in_bbox_cb, NULL);
  can = vcl_canvas_new (lear);
  vcl_canvas_setup (can, VCL_CANVAS_REAL_UNITS | VCL_CANVAS_FLIP_Y, 0.5, 0.5, 4);

  gtk_box_pack_start (GTK_BOX (vbox), entry, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), b1, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), b2, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), can -> gtk -> widget, TRUE, TRUE, 0);

  gtk_container_add (GTK_CONTAINER (win), hbox);


  gtk_signal_connect (GTK_OBJECT (win), "delete_event",
                      GTK_SIGNAL_FUNC (on_win_delete_event), NULL);
  gtk_signal_connect (GTK_OBJECT (b1), "clicked",
                      GTK_SIGNAL_FUNC (on_button_next_clicked), lear);
  gtk_signal_connect (GTK_OBJECT (b2), "clicked",
                      GTK_SIGNAL_FUNC (on_button_close_clicked), NULL);

  gtk_widget_show_all (win);
}

int
main (int argc, char ** argv)
{
  gtk_set_locale ();
  vcl_init ();
  gtk_init (&argc, &argv);
  create_windows ();
  gtk_main ();
}




