#ifndef _VCL_RASTER_COMPOSE_H_
#define _VCL_RASTER_COMPOSE_H_

/* Classical Porter-Duff composing operators, 
   src1, src2 and dst have to have equal depth and number of channels.
 */

extern void
vcl_compose_over_ll (struct vcl_pixbuf *src1, struct vcl_pixbuf *src2,
		     struct vcl_pixbuf *dst);

extern void
vcl_compose_in_ll (struct vcl_pixbuf *src1, struct vcl_pixbuf *src2,
		   struct vcl_pixbuf *dst);

extern void
vcl_compose_out_ll (struct vcl_pixbuf *src1, struct vcl_pixbuf *src2,
		    struct vcl_pixbuf *dst);

extern void
vcl_compose_atop_ll (struct vcl_pixbuf *src1, struct vcl_pixbuf *src2,
		     struct vcl_pixbuf *dst);

extern void
vcl_compose_xor_ll (struct vcl_pixbuf *src1, struct vcl_pixbuf *src2,
		    struct vcl_pixbuf *dst);

/* Dissolve operation, defacto Porter-Duff in operator, 
   src, alpha and dst have to have equal depth,
   src and dst have to have equal number of channels. 
 */

extern void
vcl_dissolve_ll (struct vcl_pixbuf *src, struct vcl_pixbuf *alpha, struct vcl_pixbuf *dst);


#endif
