#ifndef _VCL_RASTER_DECOMPOSER_H_
#define _VCL_RASTER_DECOMPOSER_H_


struct vcl_dc_segment
{
  double x, dxy;
  int y, dy;
};

struct vcl_decomposer
{
  int depth;
  int aa_level;
  struct vcl_rectangle area;
  struct vcl_growing_array segments;
};


extern struct vcl_decomposer *
vcl_decomposer_new (int depth, int aa_level);

extern void 
vcl_decomposer_add_segment (struct vcl_decomposer *dc, struct geom_point f, struct geom_point t);

extern struct vcl_rle_data *
vcl_decomposer_compute (struct vcl_decomposer *dc);

static inline void
vcl_decomposer_get_bbox (struct vcl_decomposer *dc, struct vcl_rectangle *bbox)
{ *bbox = dc -> area; }

extern void
vcl_decomposer_destroy (struct vcl_decomposer *dc);


#endif
