#ifndef _VCL_RASTER_PIXBUF_H_
#define _VCL_RASTER_PIXBUF_H_


struct vcl_pixbuf
{
  u8 channels;
  s8 alpha;
  u8 depth;
  u8 flags;
  uns rowstride;
  uns width;
  uns height;
  u8 *data;
};


extern struct vcl_pixbuf *
vcl_pixbuf_new (u8 channels, s8 alpha, u8 depth, uns width, uns height);

extern struct vcl_pixbuf *
vcl_pixbuf_new_from_data (u8 channels, s8 alpha, u8 depth,
			  uns width, uns height, uns rowstride, void * data);

extern struct vcl_pixbuf *
vcl_pixbuf_init_from_data (struct vcl_pixbuf *pb, u8 channels, s8 alpha, u8 depth,
			   uns width, uns height, uns rowstride, void * data);

extern struct vcl_pixbuf *
vcl_pixbuf_new_by_template (const struct vcl_pixbuf *src);

extern struct vcl_pixbuf *
vcl_pixbuf_new_subblock (const struct vcl_pixbuf *src, uns offset_x, uns offset_y,
			 uns width, uns height);

extern struct vcl_pixbuf *
vcl_pixbuf_init_subblock (struct vcl_pixbuf *pb, const struct vcl_pixbuf *src,
			  uns offset_x, uns offset_y, uns width, uns height);

struct vcl_pixbuf *
vcl_pixbuf_new_copy (const struct vcl_pixbuf *src);

extern void
vcl_pixbuf_fill (struct vcl_pixbuf *dst, u8 *data);

extern void
vcl_pixbuf_render (struct vcl_pixbuf * src, struct vcl_pixbuf *dst);


#endif
