#ifndef _VCL_RASTER_RLE_DATA_H_
#define _VCL_RASTER_RLE_DATA_H_


struct vcl_rle_line
{
  u8 *datas;
  uns *ends;
  uns width;
};

struct vcl_rle_data
{
  u8 depth;
  uns width;
  uns height;
  uns offset_x;
  uns offset_y;
  struct vcl_rle_line *lines;
};


extern struct vcl_rle_data *
vcl_rle_data_new (u8 depth, uns width, uns height);

extern struct vcl_rle_data *
vcl_rle_data_new_subblock (const struct vcl_rle_data *src, uns offset_x, uns offset_y, 
			   uns width, uns height);

extern struct vcl_rle_data *
vcl_rle_data_init_subblock (struct vcl_rle_data *rd, const struct vcl_rle_data *src,
			    uns offset_x, uns offset_y, uns width, uns height);

extern void
vcl_rle_data_add_line (struct vcl_rle_data *rd, uns lineno, uns width,
		       const u8* datas, const uns* ends);

extern void
vcl_rle_data_crop_bbox (struct vcl_rle_data *rd, struct vcl_rectangle *src, 
			struct vcl_rectangle *dst);

extern void
vcl_rle_data_render (struct vcl_rle_data * src, struct vcl_pixbuf *dst);


#endif
