#include "vcl_internal.h"

#include <stdio.h>
#include <stdlib.h>


#define GA_INIT_SIZE 16
#define GA_MULT_TENTH 14


void
vcl_ga_init (struct vcl_growing_array *ga, int init_items, int item_size)
{
  ga -> array = NULL;
  ga -> used = 0;
  ga -> size = init_items;
  ga -> item_size = item_size;

  if (init_items != 0)
    {
      ga -> array = xmalloc_zero (init_items * item_size);
    }
}

void
vcl_ga_ensure (struct vcl_growing_array *ga, int pos)
{
  if (pos >= ga -> size)
    {
      int newsize = (ga -> size == 0) ? GA_INIT_SIZE : ga -> size;

      while (pos >= newsize)
	newsize = ((newsize * GA_MULT_TENTH) / 10) + 1;

      ga -> size = newsize;
      ga -> array = xrealloc (ga -> array, newsize * ga -> item_size);
    }
}
