#ifndef _VCL_LE_AREA_H_
#define _VCL_LE_AREA_H_


extern vcl_vtable *vcl_vt_le_area;
#define VCL_LE_AREA_P(X) (VCL_CLASS_P(X, vcl_vt_le_area)

struct vcl_le_area;

typedef void (* get_bbox_of_child_fn_t) (void * child_id, struct vcl_le_area * questioner,
					 struct geom_rectangle *bbox, void * data);
typedef void * (* expand_child_fn_t) (void * child_id, struct vcl_le_area * questioner,
				      void * data);
typedef void (* get_children_fn_t) (struct vcl_le_area * questioner, uns backwards,
				   const struct geom_rectangle * bbox, void * data);


typedef struct cht_htx
{
  unsigned int size, count;
  void** table;
} cht_htx;

struct vcl_le_area
{
  struct vcl_object header;
  struct geom_rectangle bbox;
  void *parent;
  void *temporary;
  int data;

  cht_htx cht;

  get_bbox_of_child_fn_t gboc_cb;
  expand_child_fn_t ec_cb;
  get_children_fn_t gc_cb;

  void *gboc_data;
  void *ec_data;
  void *gc_data;
};


extern struct vcl_le_area *
vcl_le_area_new (get_bbox_of_child_fn_t cb1, void * cb1_data,
		 expand_child_fn_t cb2, void * cb2_data,
		 get_children_fn_t cb3, void * cb3_data);

extern void
vcl_le_area_flush (struct vcl_le_area * obj);

extern void
vcl_le_area_answer_child_in_bbox (struct vcl_le_area * obj, void * child_id);

extern void
vcl_le_area_child_altered_notification (struct vcl_le_area * obj, void * child_id,
					const struct geom_rectangle *where);

extern void
vcl_le_area_child_changed_notification (struct vcl_le_area * obj, void * child_id,
					const struct geom_rectangle *old_bbox,
					const struct geom_rectangle *new_bbox);
extern void
vcl_le_area_child_transformed_notification (struct vcl_le_area * obj, void * child_id,
					    const struct geom_rectangle *old_bbox,
					    const struct geom_rectangle *new_bbox,
					    const struct geom_transform2 * trans);
extern void
vcl_le_area_child_appeared_notification (struct vcl_le_area * obj, void * child_id);

extern void
vcl_le_area_child_disappeared_notification (struct vcl_le_area * obj, void * child_id);

extern void *
vcl_le_area_child_lookup (struct vcl_le_area * obj, void * child_id);

extern void
vcl_le_area_child_unlock (struct vcl_le_area * obj, void * child_id);


#ifdef _VCL_INTERNAL_


extern void
vcl_le_area_main (void);


#endif
#endif
