#ifndef _VCL_OBJECT_H_
#define _VCL_OBJECT_H_

typedef void * vcl_vtable;

struct vcl_object
{
  vcl_vtable *vt;
};

extern int vcl_if_object;
extern int vcl_mid_object_destroy;


#define VCL_FN_CALL(OBJ, RETVAL, ...) ((*((RETVAL (*)(struct vcl_object *, ...)) (OBJ))) (__VA_ARGS__))
#define VCL_METHOD(RETVAL, ID, ...) (VCL_FN_CALL (((struct vcl_object *) obj) -> vt [ID], RETVAL, obj , ## __VA_ARGS__))
#define VCL_CLASS_P(OBJ, CLASS_ID) ((((struct vcl_object *) OBJ) -> vt) == CLASS_ID)
#define VCL_GET_CLASS(OBJ) (((struct vcl_object *) OBJ) -> vt)

static inline void
vcl_object_destroy (void * obj)
{ VCL_METHOD (void, vcl_mid_object_destroy); }

extern uns
vcl_class_supports_interface_p (vcl_vtable *klass, int iface);


#ifdef _VCL_INTERNAL_

struct vcl_class_dsc
{
  const char *name;
  int class_id;
};

struct vcl_iface_dsc
{
  int first_fn;
  int fn_count;
  const char *name;
};


extern int
vcl_interface_new (const char *name);

extern int
vcl_interface_add_method (int iface);

extern vcl_vtable *
vcl_class_new (const char *name);

extern void
vcl_class_add_interface (vcl_vtable *klass, int iface);

extern void
vcl_class_add_method (vcl_vtable *klass, int iface, int mid, void *call);

extern void
vcl_class_add_method_li (int mid, void *call);

extern void
vcl_object_init (void *ptr, vcl_vtable *tbl);




extern void
vcl_object_main (void);


#endif
#endif
