#ifndef _VCL_PROPERTY_H_
#define _VCL_PROPERTY_H_


extern vcl_vtable *vcl_vt_property;


struct vcl_property
{
  struct vcl_object header;
  struct vcl_growing_array values;
  struct vcl_growing_array control;

  void * child;
  void * parent;
  int data;
};


static inline uns
vcl_property_p (void *obj)
{ return (VCL_CLASS_P (obj, vcl_vt_property)); }

extern struct vcl_property *
vcl_property_new (void);

extern void
vcl_property_set (struct vcl_property * obj, int prop_id, void *prop_data);

extern int
vcl_property_get_count (struct vcl_property * obj);

extern int
vcl_property_get_nth_type (struct vcl_property * obj, int n);

extern void *
vcl_property_get_nth_value (struct vcl_property * obj, int n);

extern void *
vcl_property_get (struct vcl_property * obj, int prop_id);


static inline void
vcl_property_set_fill_color (void  *prop, u32 color)
{ vcl_property_set (prop, VCL_PROP_FILL_COLOR, &color); }

static inline void
vcl_property_set_stroke_color (void  *prop, u32 color)
{ vcl_property_set (prop, VCL_PROP_STROKE_COLOR, &color); }

static inline void
vcl_property_set_stroke_width (void  *prop, double width)
{ vcl_property_set (prop, VCL_PROP_STROKE_WIDTH, &width); }


#ifdef _VCL_INTERNAL_


extern void
vcl_property_main (void);


#endif
#endif
