#include "vdl_internal.h"

#include <stdio.h>
#include <stdlib.h>

struct vdl_traps *
vdl_traps_new (int size)
{
  MALLOCATED (struct vdl_traps, tp);

  tp -> traps_used = 0;
  tp -> traps_size = (size < 3) ? 16 : size;
  tp -> traps = xmalloc (tp -> traps_size * sizeof (XTrapezoid));
return (tp);
}

void
vdl_traps_destroy (struct vdl_traps *tp)
{
  xfree (tp -> traps);
  xfree (tp);
}

void
vdl_traps_flush (struct vdl_traps *tp)
{
  tp -> traps_used = 0;
}

void
vdl_traps_enlarge_buffer (struct vdl_traps *tp)
{
  tp -> traps_size *= 2;
  tp -> traps = xrealloc (tp -> traps, tp -> traps_size * sizeof (XTrapezoid));
}

