#ifndef _VDL_TRAPS_H
#define _VDL_TRAPS_H

#ifdef _VDL_INTERNAL_

struct vdl_traps
{
  XTrapezoid *traps;
  int traps_used;
  int traps_size;
};

extern struct vdl_traps * vdl_traps_new (int size);
extern void vdl_traps_destroy (struct vdl_traps *tp);
extern void vdl_traps_flush (struct vdl_traps *tp);
extern void vdl_traps_enlarge_buffer (struct vdl_traps *tp);

static inline void
vdl_traps_add (struct vdl_traps *tp, xxxnum_t l1, xxxnum_t l2,
		xxxnum_t lx1, xxxnum_t ly1, xxxnum_t lx2, xxxnum_t ly2,
		xxxnum_t rx1, xxxnum_t ry1, xxxnum_t rx2, xxxnum_t ry2)
{
  XTrapezoid *t;
  if (tp -> traps_used == tp -> traps_size) vdl_traps_enlarge_buffer (tp);
  t = tp -> traps + tp -> traps_used ++;

  //      printf ("AA %f %f -  %f, %f, %f, %f, %f, %f, %f, %f\n", l1, l2, lx1, ly1, lx2, ly2, rx1, ry1, rx2, ry2);

  t -> top = XDoubleToFixed (l1);
  t -> bottom = XDoubleToFixed (l2);
  t -> left . p1 . x = XDoubleToFixed (lx1);
  t -> left . p1 . y = XDoubleToFixed (ly1);
  t -> left . p2 . x = XDoubleToFixed (lx2);
  t -> left . p2 . y = XDoubleToFixed (ly2);
  t -> right . p1 . x = XDoubleToFixed (rx1);
  t -> right . p1 . y = XDoubleToFixed (ry1);
  t -> right . p2 . x = XDoubleToFixed (rx2);
  t -> right . p2 . y = XDoubleToFixed (ry2);
}

#endif
#endif
